--[
renoise.tool():add_menu_entry {
  name = "Sample Editor:Process:selection+upbeat...",
  invoke = function() 
    test_main()
  end
 }
--]]

require ("selection_with_upbeat")

function test_main ()
local vb = renoise.ViewBuilder()
local get_x = 0

local dialog_content = 
 vb:column
  { 
    vb:row
    { 
        vb:textfield
        { 
          width = 140,
          text = " upbeat number ",
          notifier =
           function(x)       
             if pcall(loadstring('return '..x))==false
                or
               loadstring("return "..x)()<0
              then
               renoise.app():show_error(
               [[Enter a number greater than zero,
                or a numerical formula.
                e.g.
                '1.5' , '1/4' , '8*1.5/3']])
             else get_x=loadstring("return "..x)() 
             end
            end
        },
        

        
        vb:button
        {
            width = 8,
            text = ("?"),
            notifier = 
              function()
               renoise.app():show_message(
               [[
               For sample offset etc.,
               select the sample range,
               and input the number or the formula
               that represents upbeat.              
               e.g.
                '1.5' , '1/4' , '8*1.5/3']])
              end,
         }              
    },
    
    vb:row
    {
        vb:button
        {
            width = 80,
            text = ("replace  "),
            notifier = 
              function()
                get_init_env()
                replace_with_upbeat (get_x)
              end,
         midi_mapping = "replace the sample :selection+upbeat"
         },
     
        vb:button
         {
            width = 80,
            text = "add new  ",
            notifier =
              function()
                get_init_env()
                set_new_with_upbeat (get_x)
             end,
         midi_mapping = "add new sample :selection+upbeat"
        },
    }
  }
 renoise.app():show_custom_dialog("Selection + upbeat" , dialog_content)
end

